<?php

/**
 * co_aprueba_revision_ep actions.
 *
 * @package    contratacion
 * @subpackage co_aprueba_revision_ep
 * @author     Manuel Enrique Paredes Lopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_aprueba_revision_epActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_APRUEBA_REVISION_EP',
        'CO_ESTUDIOS_PREVIOS',
        'INTERCEROS'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_ESTUDIOS_PREVIOS' =>
        array (
            'id_estudios_previos' => 'CO_APRUEBA_REVISION_EP'
        ),
        'INTERCEROS' =>
        array (
            'id_mae_ter' => 'CO_APRUEBA_REVISION_EP'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_APRUEBA_REVISION_EP' =>
        array(
            'id' => 'id',
            'id_estudios_previos' => 'id_estudios_previos',
            'id_mae_ter' => 'id_mae_ter',
            'estado' => 'estado',
            'fecha' => 'fecha',
            'observacion' => 'observacion'
        ),
        'INTERCEROS' =>
        array(
            'num_doc' => 'num_doc',
            'razon_soc' => 'razon_soc',
            'num_doc,||, - ,||,razon_soc' => 'completo'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id ASC'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_APRUEBA_REVISION_EP' =>
        array(    
            'id' => array('=' => array('id')),
            'id_estudios_previos' => array('=' => array('id_estudios_previos')),
            'id_mae_ter' => array('=' => array('id_mae_ter')),
            'estado' => array('=' => array('estado'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//   protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id'; //identificador de la tabla
    protected $id_names = array('id'); //llave primaria
    protected $field_names = array('id_estudios_previos', 'id_mae_ter', 'estado','fecha','observacion'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_APRUEBA_REVISION_EP'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id'; //identificador unico de la tabla

    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $request['fecha']      = CN_TABLE::fechaSistema();
            $request['id_mae_ter'] = $request['id_username'];
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        $id_mae_ter = $request['id_username'];
        $id_estudios_previos = $request['id_estudios_previos'];
        $aplica_aprobacion   = 1;


        $sql = <<<EOD
            SELECT ID,
            ID_ROL_EP,
            ID_ESTUDIOS_PREVIOS,
            ID_MAE_TER
            FROM CO_ROLES_EP
            WHERE 1=1 AND ID_ESTUDIOS_PREVIOS = $id_estudios_previos AND ID_MAE_TER = $id_mae_ter 
EOD;
        $records = CN_TABLE::executeSQL($sql);

        if (count($records) == 0) {
            $errors['mensaje'] = "El Usuario no tiene permisos para aprobar.";
            $errors['servicio'] = "co_aprueba_revision_ep";
        }


        $sql = <<<EOD
            SELECT ID,
            ID_ESTUDIOS_PREVIOS,
            ID_MAE_TER,
            ESTADO,
            FECHA,
            OBSERVACION
            FROM CO_APRUEBA_REVISION_EP 
            WHERE 1=1 AND ID_ESTUDIOS_PREVIOS = $id_estudios_previos AND ID_MAE_TER = $id_mae_ter
EOD;
        $records = CN_TABLE::executeSQL($sql);

        if (count($records) > 0) {
            $errors['mensaje'] = "El Usuario ya realizo el registro de Aprobacion/Rechazo.";
            $errors['servicio'] = "co_aprueba_revision_ep";
        }



        $sql = <<<EOD
            SELECT ID,
            ID_ESTUDIOS_PREVIOS,
            ID_MAE_TER,
            ESTADO,
            FECHA,
            OBSERVACION
            FROM CO_VOBO_REVISION_EP
            WHERE 1=1 AND ID_ESTUDIOS_PREVIOS = $id_estudios_previos AND ID_MAE_TER = $id_mae_ter AND ESTADO != 1
EOD;
        $recordss = CN_TABLE::executeSQL($sql);

        if (count($recordss) > 0) {
            $errors['mensaje'] = "El estudio previo no tiene VoBo.";
            $errors['servicio'] = "co_aprueba_revision_ep";
        }



        return $errors;
    }

    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
